import matplotlib.pyplot as plt

from argparse import ArgumentParser

parser = ArgumentParser()
parser.add_argument('table_to_plot', help='CO or GC table to plot')
args = parser.parse_args()

fh = open(args.table_to_plot)

color_dict = {'T': 'red', 'N':'blue', 'AP':'red', 'AR':'blue'}
from collections import OrderedDict
ind_dict = OrderedDict()

fig = plt.figure()
ax = fig.add_subplot(111)
counter = 0
longest = 0
for line in fh:
    if line.startswith('#'): continue
    ll = line.rstrip().split('\t')
    if len(ll) == 1:
        ind = ll[0]
        ind_dict[ind] = []
        counter += 1
        continue
    start, end = map(int, ll[3:5])
    type = ll[0]
    if end > longest:
        longest = end
    ind_dict[ind].append([start, end, type])
    #ax.plot([start, end], [counter, counter], linewidth=2.0, color=color_dict[type])

for counter, ind in enumerate(ind_dict):
    counter += 1 # Don't start at 0
    if counter == 51: print ind
    for inniecounter, element in enumerate(ind_dict[ind]):
        start, end, type = element
        print [ind, start, end]
        ax.plot([start, end], [counter, counter], linewidth=2.0, color=color_dict[type])

plt.ylabel('Individuals')
plt.xlabel('Position on chromosome (1e7)')
plt.xlim([0,longest])
import os
if 'txt' in args.table_to_plot:
    out = os.path.basename(args.table_to_plot.replace('.txt','.png'))
plt.savefig(out, dpi=300,bbox_inches='tight')
plt.show()

'''
for counter, ind in enumerate(ind_dict):
    number_of_haplos.append(len(ind_dict[ind]))
    counter += 1
    print ind, len(ind_dict[ind])

    for line in ind_dict[ind]:
        length_of_haplos.append(int(line[-1]))
        start_pos, end_pos = int(line[3]), int(line[4])
        type = line[0]
        #ax.plot([start_pos, end_pos], [counter,counter], linewidth=2.0, color=color_dict[type])
        print '\t'.join(line)
'''
