STEPSIZE = 10000

from collections import OrderedDict
from argparse import ArgumentParser
import os
parser = ArgumentParser()
parser.add_argument("map_txt", help="Merged output of 2-mergeCOs.py")
parser.add_argument("map", help="Map-file of the chromosome in question")
parser.add_argument("type", help="Either 'GC' or 'CO'")

args = parser.parse_args()


map_f =args.map
max_length = int(os.popen("tail -1 " + map_f).read().replace(",","").split("\t")[-1])

bin_dict = OrderedDict()
for i in range(0, max_length, STEPSIZE):
    bin_dict[i] = 0

type = args.type
if type == "CO":
    # we have to ignore the first crossover - that's basically from "nothing" to genotype
    ignore = True
    ylabel = "Crossover density"
else:
    # we don't have to ignore the first event
    ylabel = "Gene conversion density"
    ignore = False

fh = open(args.map_txt)
for line in fh:
    if line.startswith('#'): continue
    ll = line.rstrip("\n\r").split("\t")
    if len(ll) == 1:
        inside = True
        continue
    if inside and ignore:
        # ignore the first crossover event of an individual
        inside = False
        continue
    start, end = int(ll[3]), int(ll[4])
    # now find the bin for this start point
    previous_start = 0
    found = False
    for bin_start in bin_dict:
        if bin_start > start:
            bin_dict[previous_start] += 1
            found = True
            break
        previous_start = bin_start
    assert found

x = bin_dict.keys()
y = bin_dict.values()
import matplotlib.pylab as plt
plt.plot(x,y, 'k.')
plt.ylabel(ylabel)
plt.xlabel("Position on chromosome (1e7)")
plt.xlim((-5000, max(x)+5000))
plt.ylim((0,max(y) + 1))
plt.show()
output = map_f.replace(".map", ".png")
import sys
sys.stderr.write("Plotting to %s\n" %output)
#plt.savefig(output)
